专栏首页python3Python28 异常

Python28 异常

参考 http://www.cnblogs.com/wupeiqi/articles/5017742.html

异常

name = ['zhangsan','lisi']
print (name[3])
data = {'name':'Amy'}
print (data['name'])

执行结果:
Traceback (most recent call last):
  File "E:/python/代码练习/B1.py", line 20, in <module>
    print (name[3])
IndexError: list index out of range
#并不存在name[3]这个元素,所以会报错;但是因为报错的原因整个程序就崩溃了,下面的代码就不会再去执行。
data = {}

try:    #尝试执行下面的代码
    data['name']
except KeyError as k:   
#否则如果出现了KeyError这个错误,就执行下面的代码;
#如果出现KeyError错误,就捕获错误结果然后赋值给这个k(也可以起其他的名字)
    print ('没有这个key',k)

执行结果:
没有这个key 'name'
name = ['zhangsan','lisi']
data = {}
try:
    name[3]     #报错
    data['name']    #这里没有执行
except KeyError as k: #这里没有执行
    print ('没有这个key',k)
except IndexError as k:  #因为尝试name[3],但是报错后直接代码就到了这里;只要出现一个错误,就不会处理其他错误。
    print ('列表元素不存在',k)

执行结果:
列表元素不存在 list index out of range
name = ['zhangsan','lisi']
data = {}
try:
    name[3]
    data['name']
except (KeyError,IndexError) as k:  #可以通过括号将多种错误写到一起;这种方式适用当出现错误时使用同一种处理办法的场景
    print ('错误:',k)

执行结果:
错误: list index out of range

name = ['zhangsan','lisi']
data = {}
try:
    # name[3]   #注释掉
    data['name']
except (KeyError,IndexError) as k:
    print ('错误:',k)

执行结果:
错误: 'name'
#从上到下的错误执行顺序
name = ['zhangsan','lisi']
data = {}
try:
    # name[3]
    # data['name']
    open('abc.txt')
except KeyError as k:
    print ('没有这个key',k)
except IndexError as k:
    print ('列表元素不存在',k)

except Exception as k:  #使用Exception能抓取大部分错误;使用场景是当预判的错误没有触发,但触发了自己没有预判的错误时,可以使用Exception
    print ('未知错误',k)

执行结果:
未知错误 [Errno 2] No such file or directory: 'abc.txt'
try:
    a = 123
    print (a)
except KeyError as k:
    print ('没有这个key',k)
except IndexError as k:
    print ('列表元素不存在',k)

except Exception as k:
    print ('未知错误',k)
else:   #当没有任何错误时,执行else下面的代码
    print ('一切正常')

执行结果:
123
一切正常
try:
    open('abc.txt')
    a = 123
    print (a)
except KeyError as k:
    print ('没有这个key',k)
except IndexError as k:
    print ('列表元素不存在',k)

except Exception as k:
    print ('未知错误',k)
else:
    print ('一切正常')

finally:
    print ('不管有没有错误,都执行该代码')

执行结果:
未知错误 [Errno 2] No such file or directory: 'abc.txt'
不管有没有错误,都执行改代码
try:

    a = 123
    print (a)
except KeyError as k:
    print ('没有这个key',k)
except IndexError as k:
    print ('列表元素不存在',k)

except Exception as k:
    print ('未知错误',k)
else:
    print ('一切正常')

finally:
    print ('不管有没有错误,都执行该代码')

执行结果:
123
一切正常
不管有没有错误,都执行该代码
ValueError错误:

s1 = 'hello'
try:
    int(s1)
except ValueError as e:
    print (e)

执行结果:
invalid literal for int() with base 10: 'hello'

常用异常:

AttributeError 试图访问一个对象没有的树形,比如foo.x,但是foo没有属性x
IOError 输入/输出异常;基本上是无法打开文件
ImportError 无法引入模块或包;基本上是路径问题或名称错误
IndentationError 语法错误(的子类) ;代码没有正确对齐
IndexError 下标索引超出序列边界,比如当x只有三个元素,却试图访问x[5]
KeyError 试图访问字典里不存在的键
KeyboardInterrupt Ctrl+C被按下
NameError 使用一个还未被赋予对象的变量
SyntaxError Python代码非法,代码不能编译(语法错误)
TypeError 传入对象类型与要求的不符合 
UnboundLocalError 试图访问一个还未被设置的局部变量,基本上是由于另有一个同名的全局变量,
导致你以为正在访问它
ValueError 传入一个调用者不期望的值,即使值的类型是正确的

更多异常:

ArithmeticError
AssertionError
AttributeError
BaseException
BufferError
BytesWarning
DeprecationWarning
EnvironmentError
EOFError
Exception
FloatingPointError
FutureWarning
GeneratorExit
ImportError
ImportWarning
IndentationError
IndexError
IOError
KeyboardInterrupt
KeyError
LookupError
MemoryError
NameError
NotImplementedError
OSError
OverflowError
PendingDeprecationWarning
ReferenceError
RuntimeError
RuntimeWarning
StandardError
StopIteration
SyntaxError
SyntaxWarning
SystemError
SystemExit
TabError
TypeError
UnboundLocalError
UnicodeDecodeError
UnicodeEncodeError
UnicodeError
UnicodeTranslateError
UnicodeWarning
UserWarning
ValueError
Warning
ZeroDivisionError

自定义异常

class LiSiException(Exception): #自动以异常的名字为:LiSiException
#括号中的Exception是继承Exception这个基类
    def __init__(self, msg):
        self.message = msg  #触发异常后的信息

try:
    raise LiSiException('自定义异常')  
    #因为不是python自带的异常,所以需要raise来触发;
    #'自定义异常'会被传给self.message
except LiSiException as info:   #将触发后的信息赋值给info
    print (info)

执行结果:
自定义异常

本文参与腾讯云自媒体分享计划,欢迎正在阅读的你也加入,一起分享。

我来说两句

0 条评论
登录 后参与评论

相关文章

  • Python学习-3天--列表与元组

          列表是Python中最基本的数据结构。序列中的每个元素都分配一个数字 - 它的位置,或索引,第一个索引是0,第二个索引是1,依此类推。(python...

    用户2398817
  • Python多线程之线程创建和终止

    python主要是通过thread和threading这两个模块来实现多线程支持。python的thread模块是比较底层的模块,python的threadin...

    用户2398817
  • Python面向对象编程Day 26部分

    多态概念指出了对象如何通过他们共同的属性和动作来操作和访问,而不需考虑他们具体的类、多态表明了动态(又名:运行时)绑定的存在,允许重载及运行时类型确定和验证。多...

    用户2398817
  • python_笔记3_list列表(有序

    append('元素') 把一个元素推到列表末尾 inset('索引','元素') 把一个元素插入到列表指定位置 pop() 把一个元素从列表末尾推出,...

    用户2398817
  • Xcode9 上传出现ERROR ITMS-90023/iTunes Store Operation Failed错误

    傅_hc
  • python代码优化案例分析

    type(0),type(42)等都是同一个对象“<type 'Int'>”,没有必要进行值得比较。因为每一个类型只有一个类型对象。

    用户2398817
  • 二叉搜索树

    用户1733462
  • RSS的发展历史简单回顾

        作者:田春峰     链接:http://blog.csdn.net/accesine960/archive/2005/03/05/312308.asp...

    田春峰-JCJC错别字检测
  • 算法、硬件、框架,2019年AI何去何从?

    过去一年,关于人工智能的事件、发现和发展比比皆是。很难从这些嘈杂的环境里分辨出关于 AI 的真实信号,即便可以,很多人也不知道那些信号表达的是什么信息。因此,我...

    机器之心
  • Component之TFTP

    Trivial File Transfer Protocol,TCP/IP中的一种简单文件传输协议,通常基于UDP实现,端口号69。

    Taishan3721

扫码关注云+社区

领取腾讯云代金券